---
# file: roles/vim/tasks/main.yml

# TODO: add recursive
# TODO: remove modules that break things
- name: Get the vim config
  git:
    repo: 'git://github.com/geoffjay/dotvim.git'
    dest: /home/crdc/.vim
    update: no

# TODO: change this to vim-plug
# TODO: change the dest to put the leading path in the first line
- name: Get the plugins
  git: repo={{ item.repo }} dest={{ item.dest }}
  with_items:
    - { repo: 'git://github.com/sjl/gundo.vim.git', dest: '/home/crdc/.vim/bundle/gundo.vim' }
    - { repo: 'git://github.com/fholgado/minibufexpl.vim.git', dest: '/home/crdc/.vim/bundle/minibufexpl.vim' }
    - { repo: 'git://github.com/scrooloose/nerdcommenter.git', dest: '/home/crdc/.vim/bundle/nerdcommenter' }
    - { repo: 'git://github.com/scrooloose/nerdtree.git', dest: '/home/crdc/.vim/bundle/nerdtree' }
    - { repo: 'git://github.com/tomtom/tlib_vim.git', dest: '/home/crdc/.vim/bundle/tlib_vim' }
    - { repo: 'git://github.com/vim-scripts/taglist.vim.git', dest: '/home/crdc/.vim/bundle/taglist.vim' }
    - { repo: 'git://github.com/MarcWeber/vim-addon-mw-utils.git', dest: '/home/crdc/.vim/bundle/vim-addon-mw-utils' }
    - { repo: 'git://github.com/kingbin/vim-arduino.git', dest: '/home/crdc/.vim/bundle/vim-arduino' }
    - { repo: 'git://github.com/tpope/vim-fugitive.git', dest: '/home/crdc/.vim/bundle/vim-fugitive' }
    - { repo: 'git://github.com/jwhitley/vim-colors-solarized.git', dest: '/home/crdc/.vim/bundle/vim-colors-solarized' }
    - { repo: 'git://github.com/flazz/vim-colorschemes.git', dest: '/home/crdc/.vim/bundle/vim-colorschemes' }
    - { repo: 'git://github.com/mgutz/vim-colors.git', dest: '/home/crdc/.vim/bundle/vim-colors' }
    - { repo: 'git://github.com/honza/vim-snippets.git', dest: '/home/crdc/.vim/bundle/vim-snippets' }
    - { repo: 'git://github.com/aklt/plantuml-syntax.git', dest: '/home/crdc/.vim/bundle/plantuml-syntax' }
    - { repo: 'git://github.com/alvan/vim-closetag.git', dest: '/home/crdc/.vim/bundle/vim-closetag' }
    - { repo: 'git://github.com/jpo/vim-railscasts-theme.git', dest: '/home/crdc/.vim/bundle/vim-railscasts-theme' }
    - { repo: 'git://github.com/tpope/vim-bundler.git', dest: '/home/crdc/.vim/bundle/vim-bundler' }
    - { repo: 'git://github.com/vim-scripts/gtk-vim-syntax.git', dest: '/home/crdc/.vim/bundle/gtk-vim-syntax' }
    - { repo: 'git://github.com/junegunn/goyo.vim.git', dest: '/home/crdc/.vim/bundle/goyo.vim' }
    - { repo: 'git://github.com/chikamichi/mediawiki.vim.git', dest: '/home/crdc/.vim/bundle/mediawiki.vim' }
    - { repo: 'git://github.com/vim-scripts/vim-mediawiki-editor.git', dest: '/home/crdc/.vim/bundle/vim-mediawiki-editor' }
    - { repo: 'git://github.com/kana/vim-metarw.git', dest: '/home/crdc/.vim/bundle/vim-metarw' }
    - { repo: 'git://github.com/mattn/webapi-vim.git', dest: '/home/crdc/.vim/bundle/webapi-vim' }
    - { repo: 'git://github.com/mattn/vim-metarw-etcd.git', dest: '/home/crdc/.vim/bundle/vim-metarw-etcd' }
    - { repo: 'git://github.com/nikvdp/ejs-syntax.git', dest: '/home/crdc/.vim/bundle/ejs-syntax' }
    - { repo: 'git://github.com/digitaltoad/vim-jade.git', dest: '/home/crdc/.vim/bundle/vim-jade' }
    - { repo: 'git://github.com/rodjek/vim-puppet.git', dest: '/home/crdc/.vim/bundle/vim-puppet' }
    - { repo: 'git://github.com/ctrlpvim/ctrlp.vim.git', dest: '/home/crdc/.vim/bundle/ctrlp.vim' }
    - { repo: 'git://github.com/davidhalter/jedi-vim.git', dest: '/home/crdc/.vim/bundle/jedi-vim' }
    - { repo: 'git://github.com/kannokanno/previm.git', dest: '/home/crdc/.vim/bundle/previm' }
    - { repo: 'git://github.com/tpope/vim-liquid.git', dest: '/home/crdc/.vim/bundle/vim-liquid' }
    - { repo: 'git://github.com/sbl/scvim.git', dest: '/home/crdc/.vim/bundle/scvim' }
    - { repo: 'git://github.com/JamshedVesuna/vim-markdown-preview.git', dest: '/home/crdc/.vim/bundle/vim-markdown-preview' }
    - { repo: 'git://github.com/tpope/vim-markdown.git', dest: '/home/crdc/.vim/bundle/vim-markdown' }
    - { repo: 'git://github.com/vim-latex/vim-latex.git', dest: '/home/crdc/.vim/bundle/vim-latex' }
    - { repo: 'git://github.com/wavded/vim-stylus.git', dest: '/home/crdc/.vim/bundle/vim-stylus' }
    - { repo: 'git://github.com/stfl/meson.vim.git', dest: '/home/crdc/.vim/bundle/meson.vim' }
    - { repo: 'git://github.com/wakatime/vim-wakatime.git', dest: '/home/crdc/.vim/bundle/vim-wakatime' }
    - { repo: 'git://github.com/peterhoeg/vim-qml.git', dest: '/home/crdc/.vim/bundle/vim-qml' }
    - { repo: 'git://github.com/IN3D/vim-raml.git', dest: '/home/crdc/.vim/bundle/vim-raml' }
    - { repo: 'git://github.com/editorconfig/editorconfig-vim.git', dest: '/home/crdc/.vim/bundle/editorconfig-vim' }
    - { repo: 'git://github.com/posva/vim-vue.git', dest: '/home/crdc/.vim/bundle/vim-vue' }
    - { repo: 'git://github.com/digitaltoad/vim-pug.git', dest: '/home/crdc/.vim/bundle/vim-pug' }
    - { repo: 'git://github.com/vim-syntastic/syntastic.git', dest: '/home/crdc/.vim/bundle/syntastic' }
    - { repo: 'git://github.com/mxw/vim-jsx.git', dest: '/home/crdc/.vim/bundle/vim-jsx' }
    - { repo: 'git://github.com/pangloss/vim-javascript.git', dest: '/home/crdc/.vim/bundle/vim-javascript' }
    - { repo: 'git://github.com/SirVer/ultisnips.git', dest: '/home/crdc/.vim/bundle/ultisnips' }
    - { repo: 'git://github.com/Valloric/YouCompleteMe.git', dest: '/home/crdc/.vim/bundle/YouCompleteMe' }
    - { repo: 'git://github.com/ervandew/supertab.git', dest: '/home/crdc/.vim/bundle/supertab' }
    - { repo: 'git://github.com/fatih/vim-go.git', dest: '/home/crdc/.vim/bundle/vim-go' }
    - { repo: 'git://github.com/geoffjay/vim-dcs-snippets.git', dest: '/home/crdc/.vim/bundle/vim-dcs-snippets' }
    - { repo: 'git://github.com/vim-airline/vim-airline.git', dest: '/home/crdc/.vim/bundle/vim-airline' }
    - { repo: 'git://github.com/morhetz/gruvbox.git', dest: '/home/crdc/.vim/bundle/gruvbox' }
    - { repo: 'git://github.com/rust-lang/rust.vim.git', dest: '/home/crdc/.vim/bundle/rust.vim' }
    - { repo: 'git://github.com/PratikBhusal/vim-grip.git', dest: '/home/crdc/.vim/bundle/vim-grip' }
    - { repo: 'git://github.com/autozimu/LanguageClient-neovim.git', dest: '/home/crdc/.vim/bundle/LanguageClient-neovim' }
    - { repo: 'git://github.com/vim-airline/vim-airline-themes.git', dest: '/home/crdc/.vim/bundle/vim-airline-themes' }
    - { repo: 'git://github.com/vim-scripts/dbext.vim.git', dest: '/home/crdc/.vim/bundle/dbext.vim' }
    - { repo: 'git://github.com/epilande/vim-react-snippets.git', dest: '/home/crdc/.vim/bundle/vim-react-snippets' }
    - { repo: 'git://github.com/jparise/vim-graphql.git', dest: '/home/crdc/.vim/bundle/vim-graphql' }
  become_user: user

#- name: Pull vim submodules
#  shell: { repo: 'git submodule update --init --recursive' }
#  args:
#    chdir: /home/crdc/.vim

# TODO: test this
- name: Setup YouCompleteMe
  shell: python setup.py --clong-completer --go-completer --rust-completer
  args:
    chdir: /home/crdc/.vim/bundle/YouCompleteMe

# TODO: test this
- name: Setup LanguageClient
  shell: bash install.sh
  args:
    chdir: /home/crdc/.vim/bundle/LanguageClient-neovim
